/* REXX 
 * ਬ । ࠧ GIF  JPG 䠩
 * ᪮ ࠢ (C) 1998 ਩ .⥪
 *
 */

parse arg imagefile

if imagefile == "" then do
   say "Usage: getimgsize image_filename"
   exit
end

if ( rc = GetGifSize( imagefile )) == 0 then
     rc = GetJpgSize( imagefile )

if rc == 1 then
   say "Image "imagefile" size: "size.1"x"size.2

exit

/*
 * 㭪    : GetGifSize
 * 맮      : call GetGifSize ImageFile
 *         : ImageFile -  GIF 䠩
 * 頥 : 1 -  ᯥ譮 襭, 0 -  ⨢ 砥
 * ਬ砭 : ⠭ ஢ ६ "size",
 *              , size.1 - ਭ ⨭, size.2 - . 
 *       : ਩ .⥪ (GlassMan) 1998
 *
 */

GetGifSize: procedure expose size.

   parse arg file

   size.0 = 0

   if charin( file, 1, 3 ) \= 'GIF' then do
      say 'Warning: (GetGifSize) Image' file 'is not valid GIF file!'
      end
   else do
      size.1 = c2d( reverse( charin( file, 7, 2 )))
      size.2 = c2d( reverse( charin( file, 9, 2 )))
      size.0 = 2
   end
   rc = stream( file, 'c', 'close' )

return size.0 == 2
/*--------------*/

/*
 * 㭪    : GetJpgSize
 * 맮      : call GetJpgSize ImageFile
 *         : ImageFile -  JPG 䠩
 * 頥 : 1 -  ᯥ譮 襭, 0 -  ⨢ 砥
 * ਬ砭 : ⠭ ஢ ६ "size",
 *              , size.1 - ਭ ⨭, size.2 - . 
 *       : ਩ .⥪ (GlassMan) 1998
 *
 */

GetJpgSize: procedure expose size.

   parse arg file

   size.0 = 0

   if charin( file, 1, 2 ) \= 'FFD8'x then do
      say 'Warning: (GetJpgSize) Image' file 'is not valid JPG file!'
      rc = stream( file, 'c', 'close' )
      return 0
   end

   ch = '00'x

   do while ch \= 'DA'x & ch \= ''
      /* Find next marker (JPEG markers begin with 0xFF) */
      do while ch \= 'FF'x & ch \= ''
         ch = charin( file,, 1)
      end
      /* JPEG markers can be padded with unlimited */
      do while ch == 'FF'x & ch \= ''
         ch = charin( file,, 1)
      end
      /* Now, ch contains the value of the marker */
      if ch >= 'C0'x & ch <= 'C3'x then do
         rc = charin( file,, 3 )
         size.2 = c2d( charin( file,, 2 ))
         size.1 = c2d( charin( file,, 2 ))
         size.0 = 2
      end
      else do
        /* We **MUST** skip variables, since FF's within variable names are
           NOT valid JPEG markers */
        skip = c2d( charin( file,,2 ))
        rc = charin( file,, skip - 2 )
      end
   end

   rc = stream( file, 'c', 'close' )

return size.0 == 2
/*--------------*/
